package InsiemeLista;

public class InsiemeListaOmogeneo extends InsiemeLista {

  // campi dati
  protected Class elemClass;

  // costruttori
  public InsiemeListaOmogeneo(Class cl) {
    super();
    elemClass = cl;
  }

  public InsiemeListaOmogeneo() {
    this(Object.class);
  }

  // overriding funzioni proprie della classe
  // (realizzazione delle funzioni di Set)

  // overriding delle basic operations

  public boolean add(Object e) {
    if (!elemClass.isInstance(e)) return false;
    else return super.add(e);
  }

  // overriding delle bulk operations: non serve
  // overriding delle array operations: non serve
  // overriding delle funzioni speciali ereditate da Object
  public boolean equals(Object o) {
    if (super.equals(o)) {
      InsiemeListaOmogeneo ins = (InsiemeListaOmogeneo)o;
      if (elemClass.equals(ins.elemClass)) return true;
      else return false;
    }
    else return false;
  }

  public Object clone() {
	return super.clone(); // La copia di elemClass e' superficiale
  }

}
